unit adxFrmFolders;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OL_ScanFolders_IMPL, ComCtrls, Outlook2000;

type
  TfrmFolders = class(TForm)
    treeFolders: TTreeView;
  private
    FAddIn: TAddinModule;
  protected
    procedure AddTreeItems(const TreeItem: TTreeNode; Folder: MAPIFolder);
  public
    constructor Create(AAddIn: TAddinModule); reintroduce;
    destructor Destroy; override;
    property AddIn: TAddinModule read FAddIn;
  end;

var
  frmFolders: TfrmFolders;

implementation

{$R *.dfm}

{ TfrmFolders }

constructor TfrmFolders.Create(AAddIn: TAddinModule);
var
  i: Integer;
  IFolders: Folders;
begin
  inherited Create(nil);
  FAddIn := AAddIn;

  treeFolders.Items.Clear;
  IFolders := AddIn.OutlookApp.GetNamespace('MAPI').Folders;
  if IFolders.Count > 0 then
    for i := 1 to IFolders.Count do
      AddTreeItems(nil, IFolders.Item(i));
  treeFolders.SortType := stText;
end;

destructor TfrmFolders.Destroy;
begin
  FAddIn := nil;
  inherited Destroy;
end;

procedure TfrmFolders.AddTreeItems(const TreeItem: TTreeNode; Folder: MAPIFolder);
var
  i: Integer;
  Item: TTreeNode;
begin
  Item := treeFolders.Items.AddChild(TreeItem, Folder.Name);
  for i := 1 to Folder.Folders.Count do
    AddTreeItems(Item, Folder.Folders.Item(i));
end;

end.

